//load('organization.js')
//load('funder.js')
//load('datasource.js')

function initializeRPOs(rpos) {
    var defaultRPO = db.stakeholder.findOne({"alias": "default-rpo"});
    rpos.forEach(rpo => {
        let name = rpo.shortname != 'NULL'?rpo.shortname:rpo.name;
        let alias = name.toLowerCase().replace(/\s+/g, "-");
        i = 1;
        while(db.stakeholder.findOne({"alias": alias}) != null) {
            alias = alias + i.toString();
            i++;
        }
        var stakeholder = {
            "_class": "eu.dnetlib.uoamonitorservice.entities.Stakeholder",
            "type": "organization",
            "index_id": rpo.id,
            "index_name": rpo.name,
            "index_shortName": rpo.shortname,
            "statsProfile": "ie_monitor",
            "isUpload": false,
            "name": rpo.name,
            "alias": alias,
            "locale": "EN",
            "visibility": "PUBLIC",
            "topics": [],
            "defaultId": defaultRPO._id.valueOf()
        }
        db.stakeholder.save(stakeholder);
    });
    print(rpos.length  + ' RPOs has been created');
}

function initializeRFOs(rfos) {
    var defaultRFO = db.stakeholder.findOne({"alias": "default-rfo"});
    rfos.forEach(rfo => {
        let name = rfo.funder_shortname != ''?rfo.funder_shortname:rfo.funder_name;
        let alias = name.toLowerCase().replace(/\s+/g, "-");
        i = 1;
        while(db.stakeholder.findOne({"alias": alias}) != null) {
            alias = alias + i.toString();
            i++;
        }
        var stakeholder = {
            "_class": "eu.dnetlib.uoamonitorservice.entities.Stakeholder",
            "type": "funder",
            "index_id": rfo.funder_id,
            "index_name": rfo.funder_name,
            "index_shortName": rfo.funder_shortname,
            "statsProfile": "ie_monitor",
            "isUpload": false,
            "name": rfo.funder_name,
            "alias": alias,
            "locale": "EN",
            "visibility": "PUBLIC",
            "topics": [],
            "defaultId": defaultRFO._id.valueOf()
        }
        db.stakeholder.save(stakeholder);
    });
    print(rfos.length  + ' RFOs has been created');
}

function initializeDatasources(datasources) {
    var defaultRepo = db.stakeholder.findOne({"alias": "default-repo"});
    datasources.forEach(datasource => {
        let name = datasource.official_name;
        let alias = name.toLowerCase().replace(/\s+/g, "-");
        i = 1;
        while(db.stakeholder.findOne({"alias": alias}) != null) {
            alias = alias + i.toString();
            i++;
        }
        var stakeholder = {
            "_class": "eu.dnetlib.uoamonitorservice.entities.Stakeholder",
            "type": "datasource",
            "index_id": datasource.openaire_id,
            "index_name": datasource.official_name,
            "index_shortName": datasource.official_name,
            "statsProfile": "ie_monitor",
            "isUpload": false,
            "name": datasource.official_name,
            "alias": alias,
            "locale": "EN",
            "visibility": "PUBLIC",
            "topics": [],
            "defaultId": defaultRepo._id.valueOf()
        }
        db.stakeholder.save(stakeholder);
    });
    print(datasources.length  + ' repositories has been created');
}

use irishdb;

initializeRPOs(rpos);
initializeRFOs(rfos);
initializeDatasources(datasources);
